REALLOC(3)

NAME
realloc - reallocation of memory function

LIBRARY
libc

SYNOPSIS
#include <stdlib.h>
void *
realloc(void *ptr, size_t size);

DESCRIPTION
The realloc() function changes the size of the object pointed to by ptr to the size specified by size. The contents of the object are unchanged up to the lesser of the new and old sizes. If the new size is larger, the value of the newly allocated portion of the object is indeterminate. If ptr is a null pointer, the realloc() function behaves like the malloc(3) function for the specified size. Otherwise, if ptr does not match a pointer earlier returned by the calloc(3), malloc(3), or realloc() function, or if the space has been deallocated by a call to the free() or realloc() function, unpredictable and usually detrimental behavior will occur. If the space cannot be allocated, the object pointed to by ptr is unchanged. If size is zero and ptr is not a null pointer, the object it points to is freed.

RETURN VALUES
The realloc() function returns either a null pointer or a pointer to the possibly moved allocated space.

SEE ALSO
alloca(3), calloc(3), free(3), malloc(3)

STANDARDS
The realloc() function conforms to ansiC.